package com.unipi.talepis.android2022_4;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;

import android.Manifest;
import android.app.AlertDialog;
import android.content.pm.PackageManager;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity implements LocationListener {
    TextView textView;
    LocationManager locationManager;
    SQLiteDatabase db;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        textView = findViewById(R.id.textView);
        locationManager = (LocationManager) getSystemService(LOCATION_SERVICE);
        db = openOrCreateDatabase("DB1.db",MODE_PRIVATE,null);
        db.execSQL("Create table if not exists USER("+
                "email TEXT PRIMARY KEY," +
                "fullname TEXT)");
        db.execSQL("Insert or ignore into USER Values('bob@unipi.gr','Bob')");
        db.execSQL("Insert or ignore into USER Values('alice@unipi.gr','Alice papei')");
    }

    public void go1(View view) {
        if (ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED
                && ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
            ActivityCompat.requestPermissions(this,new String[]{Manifest.permission.ACCESS_FINE_LOCATION},123);
            return;
        }
        locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, this);
        //locationManager.removeUpdates(this);
    }
    public void go2(View view){
        Cursor cursor = db.rawQuery("Select * from USER",null);
        StringBuilder builder = new StringBuilder();
        while (cursor.moveToNext()){
            builder.append("Email:").append(cursor.getString(0)).append("\n");
        }
        showMessage("Users",builder.toString());
    }
    public void go3(View view){
        String newEmail = "talepis@unipi.gr";
        String fullName = "Efthimios Alepis";
        db.execSQL("Insert into USER Values(?,?)",new String[]{newEmail,fullName});
        showMessage("Result","Ok");
    }
    public void showMessage(String title, String text){
        new AlertDialog.Builder(this)
                .setCancelable(true)
                .setTitle(title)
                .setMessage(text)
                .show();
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
    }

    @Override
    public void onLocationChanged(@NonNull Location location) {
        textView.setText(location.getLatitude()+","+location.getLongitude());
    }
}